import sys

def read_int_safely():
    line = sys.stdin.readline()
    if not line: sys.exit(0)
    return int(line)

def query(I, J, K):
    print("?", I, J, K, flush=True)
    return read_int_safely()

def answer(g):
    print('!', *g, flush=True)

def solve():
    N = read_int_safely()

    tmp = query(0, 1, 2)

    g = [0] * N

    answer(g)

T = read_int_safely()

for _ in range(T):
    solve()
